﻿var loadCallBack = 0;
var submitted = false;
var autoCompletes = [null];
var autCacheLength = 10;
var autMatchSubset = false;
var intervalID;

$(document).ready(function() {
    //overlay
    $('#advancedSearchSubmit').click(function() {
        $.blockUI({ css: {
            border: 'none',
            padding: '15px',
            backgroundColor: 'transparent',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        },
            overlayCSS: {
                backgroundColor: '#fff',
                opacity: 0.6
            },
            message: '<div style="background: #fff">' +
        '<img src="/content/pics/busy.gif" style="width:200px; height:200px;"><br />' +
        '<div id="progressbar" style="position:relative; z-index:99999;"></div></div>'
        });
        //$('.blockOverlay').attr('title', 'Click to unblock').click($.unblockUI);
        //setTimeout($.unblockUI, 2000);
        $("#progressbar").progressbar({ value: 0 });
        intervalID = setInterval(updateProgress, 1200);
        //updateProgressBar();
    });

    submitted = false;

    $.preloadImages = function() {
        for (var i = 0; i < arguments.length; i++) {
            jQuery("<img>").attr("src", arguments[i]);
        };
    }

    $.preloadImages("/content/pics/dropdown.png");
    $.preloadImages("/content/pics/loadingSmall.gif");

    $('input#editSpectroDevice').keypress(function(e) {
        if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
            e.preventDefault();

            $('input#editSpectroDevice').blur();
        }
    });

    //select all the a tag with name equal to modal
    $('a[name=modal]').click(function(e) {
        //Cancel the link behavior
        e.preventDefault();
        //Get the A tag
        var id = $(this).attr('href');

        //Get the screen height and width
        var maskHeight = $(document).height();
        var maskWidth = $(window).width();

        if ($.browser.msie) {
            maskHeight = ($(document).height()) - 5;
            maskWidth = ($(window).width()) - 5;
        }

        //Set height and width to mask to fill up the whole screen
        $('#mask').css({ 'width': maskWidth, 'height': maskHeight });

        //transition effect		
        $('#mask').fadeIn(1000);
        $('#mask').fadeTo("slow", 0.8);

        //Get the window height and width
        var winH = $(window).height();
        var winW = $(window).width();

        var idH = $(id).height();
        var idW = $(id).width();

        //var ie7w = winW / 2 - idW / 2;
        //65 refers to the #dialog width in the css (eg. 65%)
        var ie7w = winW / 2 - ((winW / 100 * 65) / 2);

        //Set the popup window to center
        $(id).css('top', winH / 2 - $(id).height() / 2);
        $(id).css('left', winW / 2 - $(id).width() / 2);

        //ie 7 tweak
        if ($.browser.msie && $.browser.version.substr(0, 1) < 8) {
            $(id).css('left', ie7w);
        }

        //transition effect
        $(id).fadeIn(2000);

    });

    //if close button is clicked
    $('.window .close').click(function(e) {
        //Cancel the link behavior
        e.preventDefault();
        $('#mask, .window').hide();
    });

    //if mask is clicked
    $('#mask').click(function() {
        $(this).hide();
        $('.window').hide();
    });

    //if wrap is clicked
    $('#wrap').click(function() {
        $("#spectroMeasurementsDropDown").fadeOut('slow', function() { });
    });


    $('#selectButton').toggle(
                            function() {
                                $("#spectroMeasurementsDropDown").fadeIn('slow', function() { });
                            },
                            function() {
                                $("#spectroMeasurementsDropDown").fadeOut('slow', function() { });
                            }
                            );


    $('input#selectSpectroData').toggle(
                            function() {
                                $("#spectroMeasurementsDropDown").fadeIn('slow', function() { });
                            },
                            function() {
                                $("#spectroMeasurementsDropDown").fadeOut('slow', function() { });
                            }
                            );

    $('#measurementsCloseButton').click(
                            function() {
                                $("#spectroMeasurementsDropDown").fadeOut('slow', function() { });
                            }
                            );

    //    $('#spectroDevice').change(function() {
    //        $('#advancedSearch form').submit();
    //    });
    $('#advancedSearchReset').click(function() {
        $('#advancedSearch>form').clearForm();
        $('#advancedSearch>form').submit();
        return false;
    });
    $('#advancedSearch form').submit(function() {
        if (submitted) {
            return true;
        }
        startLoad();
        return false;
    });


    autoCompleteField("companyName");
    autoCompleteField("paintCode");
    autoCompleteField("colorName");
    autoCompleteField("modelName");
    autoCompleteField("useYear");
    autoCompleteField("stockCode");
    autoCompleteField("panelNumber");
});

function updateProgress() {
    var value = $("#progressbar").progressbar("option", "value");
    if (value < 100) {
        $("#progressbar").progressbar("value", value + 1);
        //updateProgressBar();
    }
}
function updateProgressEnd() {
    var value = $("#progressbar").progressbar("option", "value");
    for (value = value; value < 100;  value++) {
        $("#progressbar").progressbar("value", value);
    }
    clearInterval(intervalID);
}
function delay() { }
function updateProgressBar() {
    setTimeout(updateProgress, 250);
}

//function updateProgress() {
//    var value = $("#progressbar").progressbar("option", "value");
//    if (value != 100) {
//        $.ajax({ url: "/Ajax/Search.mvc/getProgressValue", async: true, data: {}, success: function(data) {
//            value = data;
//            $("#progressbar").progressbar("value", data);
//            updateProgressBar();
//        }
//        });
//        //$("#progressbar").progressbar("value", value);
//    }
//    else {
//        //updateProgressEnd();
//    }
//    
//}
function autoCompleteField(id) {



    $("#" + id).autocomplete({
        source: function(request, response) {
            // send ajax call
        $("#" + id).addClass("ui-autocomplete-loading");
            $.ajax({
                url: "/Ajax/Search.mvc/AutoComplete",
                dataType: "json",
                data: getAutoCompleteParams(id),
                success: function(data) {
                    var rows = new Array();
                    for (var i = 0; i < data.length; i++) {
                        rows[i] = { data: data[i], value: data[i].Name, result: data[i].Name };
                    }
                    response(rows);
                }
            });
        },
        minLength: 2,
        delay: 500,
        open: function() {
            $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
            $(this).removeClass("ui-autocomplete-loading");
        },
        close: function() {
            $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
        }
    });
}


function flushAllCaches() {
    for (i = 0; i < autoCompletes.length; i++) {
        autoCompletes.flushCache();
    }
    return true;
}

function getAutoCompleteParams(target) {
    var result = {
        query: $("#" + target).val(),
        target: target,
        limit: null,
        paintCode: function() { return $("input[id = 'paintCode']").val(); },
        companyName: function() { return $("input[id = 'companyName']").val(); },
        colorName: function() { return $("input[id = 'colorName']").val(); },
        modelName: function() { return $("input[id = 'modelName']").val(); },
        useYear: function() { return $("input[id = 'useYear']").val(); },
        stockCode: function() { return $("input[id = 'stockCode']").val(); },
        colorFamilyCode: function() { return $("#colorGroup option:selected").val(); },
        applicationCode: function() { return $("#applicationCode option:selected").val(); },
        chipText: function() { return $("input[id = 'chipText']").val(); },
        effectIndicator: function() { return $("input[name=effectCode]:radio:selected").val(); },
        powerSearchKeys: function() { return $("input[id = 'powerSearchKeys']").val(); },
        panelNumber: function() { return $("input[id = 'panelNumber']").val(); },
        databaseType: function() { return $("#databaseType option:selected").val(); },
        qualityGroupCode: function() { return $("#qualityGroupCode option:selected").val(); }
    };
    switch (target) {
        case "paintCode":
            result.paintCode = ""; break;
        case "companyName":
            result.companyName = ""; break;
        case "colorName":
            result.colorName = ""; break;
        case "modelName":
            result.modelName = ""; break;
        case "useYear":
            result.useYear = ""; break;
        case "stockCode":
            result.stockCode = ""; break;
        case "colorGroup":
            result.colorGroup = ""; break;
        case "applicationCode":
            result.applicationCode = ""; break;
        case "chipText":
            result.chipText = ""; break;
        case "effectIndicator":
            result.effectIndicator = ""; break;
        case "powerSearchKeys":
            result.powerSearchKeys = ""; break;
        case "panelNumber":
            result.panelNumber = ""; break;
        case "databaseType":
            result.databaseType = ""; break;
        case "qualityGroupCode":
            result.qualityGroupCode = ""; break;
    }
    return result;
}

$.fn.clearForm = function() {
    return this.each(function() {
        var type = this.type, tag = this.tagName.toLowerCase();
        if (tag == 'form')
            return $(':input', this).clearForm();
        if (type == 'text' || type == 'password' || tag == 'textarea')
            this.value = '';
        else if (type == 'checkbox' || type == 'radio')
            this.checked = false;
        else if (tag == 'select')
            this.selectedIndex = -1;
    });
};

function startLoad() {
    loadCallBack = $('#colorList').size();
    $('#colorList').each(function(i) {
        if (i == 0) {
            $(this).animate({ opacity: 0 }, 500, function() {
                $(this).animate({ height: "100px" }, 600, function() {
                    $(this).css("overflow: hidden");
                    $(this).addClass("loader");
                    $(this).html('<img src="/Content/pics/loadingBig.gif" width="66" height="66" alt="loading" id="loadingImage"/>')
                        .parent().animate({ opacity: 1 }, 900, function() {
                            submit();
                        });
                    /*$('#loadingImage').load(function() {
                    alert("loaded");
                    $(this).parent().animate({ opacity: 1 }, 900, function() {
                    alert("submitting");
                    submit();
                    });
                    });*/
                });
            });
        } else {
            $(this).animate({ opacity: 0 }, 500);
        };
    });
    return true;
};

function submit() {
    if (!submitted) {
        loadCallBack = loadCallBack - 1;
        if (loadCallBack < 1) {
            submitted = true;
            $('#advancedSearch>form').submit();
        }
    };
    return true;
};

$.fn.toggleHideShow = function(a, b) {
    $("#b1:contains('Show')") == true ? $('#b*').val().replace(a, b) : $('#b*').val().replace(b, a);
};

//$.fn.toggleHideShow = function(a, b) {
//    return this.each(function() {
//    $(this).val($("input#b1:contains('Show')") == true ? $(this).val().replace(a, b) : $(this).val().replace(b, a));
//    });
//};

$.fn.editThis = function(a) {
    $(this).editInPlace({
        bg_out: "#ffc"
    });
};

$.fn.ShowHide = function(id) {
    $(id).slideToggle();

};

$.fn.toggleButtonText = function(a, b) {
    return this.each(function() {
        $(this).val($(this).val() == a ? b : a);
    });
};

$.fn.toggleText = function(a, b) {
    return this.each(function() {
        $(this).text($(this).text() == a ? b : a);
    });
};

$.fn.setNewDeviceName = function() {
    $.ajax({ url: "/Ajax/Account.mvc/setNewDeviceName", async: true, data: { sNewDeviceName: $(this).val(), sDeviceId: $('select#spectroDevice option:selected').val() }
    });
};

/*
* Another In Place Editor - a jQuery edit in place plugin
*
* Copyright (c) 2009 Dave Hauenstein
*
* License:
* This source file is subject to the BSD license bundled with this package.
* Available online: {@link http://www.opensource.org/licenses/bsd-license.php}
* If you did not receive a copy of the license, and are unable to obtain it,
* email davehauenstein@gmail.com,
* and I will send you a copy.
*
* Project home:
* http://code.google.com/p/jquery-in-place-editor/
*
* Version 1.0.1
*
*/
eval(function(p, a, c, k, e, r) { e = function(c) { return (c < a ? '' : e(parseInt(c / a))) + ((c = c % a) > 35 ? String.fromCharCode(c + 29) : c.toString(36)) }; if (!''.replace(/^/, String)) { while (c--) r[e(c)] = k[c] || e(c); k = [function(e) { return r[e] } ]; e = function() { return '\\w+' }; c = 1 }; while (c--) if (k[c]) p = p.replace(new RegExp('\\b' + e(c) + '\\b', 'g'), k[c]); return p } ('6.1w.1x=7(q){2 r={T:"",w:"",G:"x",16:"",17:"25",18:"10",19:"#1y",H:"1z",1a:"1b...",B:"",I:"(1A 1B J 1C x)",1c:"1D 1d u",1e:U,V:"V",W:"W",X:"X",1f:\'<K y="1g">1E</K>\',1h:\'<K y="1i">1F</K>\',Y:t,1j:"C",Z:U,L:U,M:7(a){11("1k J C u: "+a.1G||\'1H 1l\')}};3(q){6.1I(r,q)}3(r.B!=""){2 s=1d 1J();s.1m=r.B}1n.1o.D=7(){E 4.z(/^\\s+/,\'\').z(/\\s+$/,\'\')};1n.1o.F=7(){E 4.z(/&/g,"&1K;").z(/</g,"&1L;").z(/>/g,"&1M;").z(/"/g,"&1N;")};E 4.1O(7(){3(6(4).5()=="")6(4).5(r.I);2 n=t;2 o=6(4);2 p=0;6(4).1P(7(){6(4).N("O",r.19)}).1Q(7(){6(4).N("O",r.H)}).12(7(){p++;3(!n){n=1R;2 f=6(4).5();2 g=(r.Y)?r.1f+\' \'+r.1h:\'\';3(f==r.I)6(4).5(\'\');3(r.G=="13"){2 h=\'<13 14="15" y="A" 1S="\'+r.18+\'" 1T="\'+r.17+\'">\'+6(4).x().D().F()+\'</13>\'}v 3(r.G=="x"){2 h=\'<1U 1p="x" 14="15" y="A" u="\'+6(4).x().D().F()+\'" />\'}v 3(r.G=="P"){2 j=r.16.1q(\',\');2 h=\'<P 14="15" y="A"><Q u="">\'+r.1c+\'</Q>\';1V(2 i=0;i<j.1W;i++){2 k=j[i].1q(\':\');2 l=k[1]||k[0];2 m=l==f?\'1r="1r" \':\'\';h+=\'<Q \'+m+\'u="\'+l.D().F()+\'">\'+k[0].D().F()+\'</Q>\'}h+=\'</P>\'}6(4).5(\'<9 y="1X" 1Y="1Z: 20; 21: 0; 22: 0;">\'+h+\' \'+g+\'</9>\')}3(p==1){7 R(){n=t;p=0;o.N("O",r.H);o.5(f);E t}7 S(){o.N("O",r.H);2 c=6(4);2 d=(c.23(\'9\'))?c.8(0).1s():c.24().8(0).1s();3(r.B!=""){2 e=\'<26 1m="\'+r.B+\'" 28="1b..." />\'}v{2 e=r.1a}o.5(e);3(r.w!=""){r.w="&"+r.w}3(r.Z){5=r.Z(o.1t("1u"),d,f,r.w);n=t;p=0;3(5){o.5(5||d)}v{11("1k J C u: "+d);o.5(f)}}v 3(r.1e&&(d==""||d==29)){n=t;p=0;o.5(f);11("1l: 2a 2b 2c a u J C 4 2d")}v{6.2e({T:r.T,1p:"2f",2g:r.W+\'=\'+d+\'&\'+r.V+\'=\'+o.1t("1u")+r.w+\'&\'+r.X+\'=\'+f,2h:"5",2i:7(a){n=t;p=0},L:7(a){2 b=a||r.I;o.5(b);3(r.L)r.L(a,o)},M:7(a){o.5(f);3(r.M)r.M(a,o)}})}E t}o.8("9").8(".A").2j().P();o.8("9").8(".1i").12(R);o.8("9").8(".1g").12(S);3(!r.Y){3(r.1j=="C")o.8("9").8(".A").1v(S);v o.8("9").8(".A").1v(R)}$(2k).2l(7(a){3(a.2m==27){R()}});o.8("9").2n(S)}})})};', 62, 148, '||var|if|this|html|jQuery|function|children|form||||||||||||||||||||false|value|else|params|text|class|replace|inplace_field|saving_image|save|trim|return|escape_html|field_type|bg_out|default_text|to|button|success|error|css|background|select|option|cancelAction|saveAction|url|null|element_id|update_value|original_html|show_buttons|callback||alert|click|textarea|name|inplace_value|select_options|textarea_cols|textarea_rows|bg_over|saving_text|Saving|select_text|new|value_required|save_button|inplace_save|cancel_button|inplace_cancel|on_blur|Failed|Error|src|String|prototype|type|split|selected|val|attr|id|blur|fn|editInPlace|ffc|transparent|Click|here|add|Choose|Save|Cancel|responseText|Unspecified|extend|Image|amp|lt|gt|quot|each|mouseover|mouseout|true|rows|cols|input|for|length|inplace_form|style|display|inline|margin|padding|is|parent||img||alt|undefined|You|must|enter|field|ajax|POST|data|dataType|complete|focus|document|keyup|keyCode|submit'.split('|'), 0, {}))