﻿$(document).ready(function() {
    removeMessage("javaDetect");
    $('.languageDropDown').sfHover();

    $('.message').each(function() {
        var oriColor = $(this).css('color');
        $(this).animate({ color: "#FFCC00" }, 500).animate({ color: oriColor }, 1000);
    });
});

jQuery.fn.sfHover = function() {
    $(this).find('li').hover(
        function() {
            $(this).addClass("sfhover");
        },
        function() {
            $(this).removeClass("sfhover");
        }
    );
}

function removeMessage(messageId) {
    $('#' + messageId).remove();
    if ($('#messages>ul').children().length == 0) {
        $('#messages').children().addClass("hidden");
    };
};
function addMessage(messageId, messageText) {
    $('#messages').children().removeClass("hidden");
    $("#messages>ul").prepend("<li class=\"close\" id=\"" + messageId + "\">" + messageText + "</li>");
    $('#' + messageId).click(function() {
        removeMessage(messageId);
    });
};


//This prototype is provided by the Mozilla foundation and
//is distributed under the MIT license.
//http://www.ibiblio.org/pub/Linux/LICENSES/mit.license
if (!Array.prototype.forEach) {
    Array.prototype.forEach = function(fun /*, thisp*/) {
        var len = this.length;
        if (typeof fun != "function")
            throw new TypeError();

        var thisp = arguments[1];
        for (var i = 0; i < len; i++) {
            if (i in this)
                fun.call(thisp, this[i], i, this);
        }
    };
}