﻿$(document).ready(function() {
    // Defines a JQuery UI Autocomplete item
    // the matching characters are bold and underlined
    $.ui.autocomplete.prototype._renderItem = function(ul, item) {
        item.label = item.label.replace(new RegExp("(?![^&;]+;)(?!<[^<>]*)(" + $.ui.autocomplete.escapeRegex(this.term) + ")(?![^<>]*>)(?![^&;]+;)", "gi"), "<u><b>$1</b></u>");
        return $("<li></li>")
                        .data("item.autocomplete", item)
                        .append("<a>" + item.label + "</a>")
                        .appendTo(ul);
    };
});